#include "fabgl.h"

// VGA 显示
fabgl::VGA16Controller DisplayController;
Canvas cv(&DisplayController);

#define HIGH 480
#define WIDTH 640
#define RADIUS 20
#define PN 5

typedef struct
{
  int x;
  int y;
  int velocity_x;
  int velocity_y;
} VPOINT;

static VPOINT vpoint[PN];

void setup() {
  Serial.begin(115200);

  DisplayController.begin();
  // 设定分辨率
  DisplayController.setResolution(VGA_640x480_60Hz);
  int             a;
  cv.setPenColor(0xFF,0,0);
  
  for (int i = 0; i < PN; i++)
  {
    vpoint[i].x = rand() % (WIDTH - RADIUS) + RADIUS;
    vpoint[i].y = rand() % (HIGH - RADIUS) + RADIUS;
    a = rand() % 361;
    vpoint[i].velocity_x = (int)((RADIUS / 5) * cos(a));
    vpoint[i].velocity_y = (int)((RADIUS / 5) * sin(a));
  }

  for (int i = 0; i < PN - 1; i++)
  {
    cv.drawLine(vpoint[i].x, vpoint[i].y,vpoint[i + 1].x, vpoint[i + 1].y);
  }
  cv.drawLine(vpoint[0].x, vpoint[0].y, vpoint[PN - 1].x, vpoint[PN - 1].y);

}

void loop() {
  cv.clear();
  for (int i = 0; i < PN; i++)
  {
    if ((vpoint[i].x <= 0) || (vpoint[i].x >= WIDTH))
      vpoint[i].velocity_x = -vpoint[i].velocity_x;
    if ((vpoint[i].y  <= 0) || (vpoint[i].y  >= HIGH))
      vpoint[i].velocity_y = -vpoint[i].velocity_y;

    vpoint[i].x += vpoint[i].velocity_x;
    vpoint[i].y += vpoint[i].velocity_y;

    for (int j = 0; j < PN - 1; j++)
    {
      cv.drawLine(vpoint[j].x, vpoint[j].y, vpoint[j + 1].x, vpoint[j + 1].y);
    }
    cv.drawLine(vpoint[0].x, vpoint[0].y, vpoint[PN - 1].x, vpoint[PN - 1].y);
  }
}
